% 5x5 degree grid resolution
alpha_res = 15; 
beta_res = 15;

channels = 1;
default_orient = [0 0 0]; % yaw pitch roll @ +Y+X-Z (OpenGL)

metadata = [];
metadata = daffv17_add_metadata( metadata, 'Description', 'String', 'Generated OpenDAFF example directivity' );
metadata = daffv17_add_metadata( metadata, 'Creation date', 'String', date );
metadata = daffv17_add_metadata( metadata, 'License', 'String', 'CC BY' );
metadata = daffv17_add_metadata( metadata, 'Generation script', 'String', 'Opendaff-v1.7/matlab/generate_examples.m' );

addpath( 'datafuncs' )

daffv17_write('filename', 'ExampleUnityOmni.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfUnityMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata);
disp( ' ' )
       
daffv17_write('filename', 'ExampleUnityUpperHemisphere.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfUnityMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata, ...
           'betarange', [ 90 180 ]);
disp( ' ' )
       
daffv17_write('filename', 'ExampleUnityLowerHemisphere.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfUnityMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata, ...
           'betarange', [ 0 90 ]);
disp( ' ' )
       
daffv17_write('filename', 'ExampleUnityFrontalHemisphere.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfUnityMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', [ 90 0 0 ], ...
           'metadata', metadata, ...
           'alpharange', [ 0 180 ] );
disp( ' ' )
       
daffv17_write('filename', 'ExampleUnityRearHemisphere.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfUnityMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', [ -90 0 0 ], ...
           'metadata', metadata, ...
           'alpharange', [ 0 180 ] );
disp( ' ' )

daffv17_write('filename', 'ExampleShortDiracOmni.ir.daff', ...
           'content', 'ir', ...
           'datafunc', @dfDiracIR, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata, ...
           'quantization', 'float32' );
disp( ' ' )
       
daffv17_write('filename', 'ExampleShortDiracOmni.ir.daff', ...
           'content', 'ir', ...
           'datafunc', @dfDiracIR, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata, ...
           'quantization', 'float32' );
disp( ' ' )

daffv17_write('filename', 'ExampleFigureOfEightFront.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfFigureOfEightMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata, ...
           'quantization', 'float32' );
disp( ' ' )

daffv17_write('filename', 'ExampleFigureOfEightSide.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfFigureOfEightMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', [ 90 0 0 ], ...
           'metadata', metadata, ...
           'quantization', 'float32' );
disp( ' ' )
       
daffv17_write('filename', 'ExampleLowPass3dBOmni.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfLowPass3dBMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata);
disp( ' ' )

daffv17_write('filename', 'ExampleLowPass6dBOmni.ms.daff', ...
           'content', 'ms', ...
           'datafunc', @dfLowPass6dBMS, ...
           'channels', channels, ...
           'alphares', alpha_res, ...
           'betares', beta_res, ...
           'orient', default_orient, ...
           'metadata', metadata);

