function sclist = ita_plottools_buttonpress_shortcuts(varargin)
% ITA_PLOTTOOLS_BUTTONPRESS_SHORTCUTS - shortcuts for ITA Toolbox GUI and
% plots

% <ITA-Toolbox>
% This file is part of the ITA-Toolbox. Some rights reserved.
% You can find the license for this m-file in the license.txt file in the ITA-Toolbox folder.
% </ITA-Toolbox>

if nargin == 1
    fgh = figure('Position',[100 100 745 650 ],'NumberTitle','off','Name','Shortcuts','Menubar','none');
    axes('parent', fgh, 'units', 'normalized' ,'position', [0.05 0.05 0.9 0.85], 'visible', 'off')

    sclist = ita_plottools_buttonpress_shortcuts;
    text(0.3,1.1,'ITA Toolbox   Shortcuts','FontName','Arial Black','FontSize',13)
    nEntries = numel(sclist);
    for iEntry = 1:nEntries
        text(0,1-1/nEntries*iEntry, sclist{iEntry},'FontName','Lucida Console','FontSize',9)
    end
    text(0.2, 1.05, 'This text is defined in: ita\_plottools\_buttonpres\_shortcuts.m','FontName',...
        'Lucida Console','FontSize',9)
    set(fgh,'KeyPressFcn',@ButtonCallback)
else
    sclist = {
        'a            - toggles between all channel and single channel modes', ...
        'b            - toggles between white or black background color without changing the data color', ...
        'Shift c            - switches interactive cursors off', ...
        'd            - opens GUI for setting axis limits', ...
        'Shift d      - change is applied to all plots of the same type', ...
        'e            - sets axis to maximize the limits', ...
        'Shift + e    - sets axis to its maximal limits and move cursors to extremities of the axis', ...
        'Enter        - switches back to command window', ...
        'l            - makes the left cursor active', ...
        'h            - opens a new figure, ... with a list of shortcuts', ...
        'Shift l      - switches off the legend', ...
        'Ctrl l       - switches on the legend', ...
        'm            - puts cursors to the maximum of all ploted channels', ...
        'Shift + m    - puts cursors to the maximum of the active channel', ...
        'q            - closes Figure', ...
        'r            - makes the right cursor active', ...
        's            - opens GUI for saving picture', ...
        'u            - shows only the part of the plot in the vicinity of the active cursor', ...
        'x            - zooms everything to cursor limits (back to original Figure)', ...
        'y            - automatic ylim settings (best fit)', ...
        'z            - enters zoom mode', ...
        'down arrow   - shift Y axis downwards', ...
        'up arrow     - shift Y axis upwards ', ...
        'Shift + down arrow - moves Y axis limits downwards while keeping the higher limit unchanged', ...
        'Shift + up arrow   - moves Y axis limits upwards while keeping the higher limit unchanged', ...
        '+            - zooms in', ...
        '-            - zooms out', ...
        'tab          - set number of samples between cursors to the next highest value of 2^N', ...
        'Shift + tab - set number of samples between cursors to the next lowest value of 2^N', ...
        '*            - move active channel up', ...
        '/            - move active channel down', ...
        };
    if nargout == 0
        for idx = 1:length(sclist)
            disp(sclist{idx})
        end
        clear sclist;
    end
end

end

function ButtonCallback(s,e) %#ok<INUSL>
% fprintf('Button callback: %s \n', e.Key);
pause(0.001)
switch(e.Key)
    case {'return','escape' }
        close
end

%end function
end

